<?php
  /**
   * Campaigns
   *
   * @package Banner Exchange Manager
   * @author wojocms.com
   * @copyright 2010
   * @version $Id: class_campaigns.php,v 1.10 2010-04-30 14:20:26 gewa Exp $
   */
  if (!defined("_VALID_PHP"))
      die('Direct access to this location is not allowed.');
  
  class Campaign
  {
      public $msgs = array();
      
      /**
       * Campaign::__construct()
       * 
       * @return
       */
      function __construct()
      {
      }
      
      /**
       * Campaign::getCampaignById()
       * 
       * @param mixed $id
       * @return
       */
      public function getCampaignById($id)
      {
          global $db;
          
          $sql = "SELECT *,DATE_FORMAT(startedon,'%D %b,%Y') as date FROM campaigns WHERE id ='" . $db->escape((int)$id) . "'";
          $row = $db->first($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }
      
      /**
       * Campaign::getCampaigns()
       * 
       * @param bool $where
       * @param bool $letter
       * @param bool $sort
       * @param bool $catid
       * @param bool $user_id
       * @return
       */
      public function getCampaigns($where = false, $letter = false, $sort = false, $catid = false, $user_id = false)
      {
          global $db, $setup, $pager;
          
          require_once(BMPATH . "lib/class_paginate.php");
          
          $pager = new Paginator();
          $counter = countEntries('campaigns');
          $pager->items_total = $counter;
          $pager->default_ipp = $setup->set['perpage'];
          $pager->paginate();
          
          if ($counter == 0) {
              $pager->limit = "";
          }
          ($where) ? $where = "WHERE c.name LIKE '%" . sanitize($where) . "%'" : "";
          ($letter) ? $where = "WHERE c.name REGEXP '^" . $db->escape(sanitize($letter)) . "'" : "";
		  ($catid) ? $where = "WHERE c.cat_id = '".$catid."'" : "";
		  ($user_id) ? $where = "WHERE c.user_id = '".$user_id."'" : "";
          ($sort) ? $order = sanitize($sort) : $order = "c.startedon DESC";
          
          $sql = "SELECT c.*,DATE_FORMAT(c.startedon,'%D %b,%Y') as started, u.id AS uid, username" 
		  . "\n FROM campaigns AS c" 
		  . "\n LEFT JOIN users AS u ON u.id = c.user_id" 
		  . "\n " . $where . "" 
		  . "\n ORDER BY " . $order . " " . $pager->limit;
          
          $row = $db->fetch_all($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }
      
      /**
       * Campaign::updateCampaign()
       * 
       * @param mixed $id
       * @return
       */
      public function updateCampaign($id, $redirect = false)
      {
          global $db, $msgAlert, $setup, $showMsg;
          
          if (isset($_POST['update_campaign']) && $_POST['update_campaign'] == 1) {
              if ($_POST['name'] == "")
                  $this->msgs['name'] = "Please Enter Campaign Name";
              
              if ($_POST['cat_id'] == 0)
                  $this->msgs['cat_id'] = "Please Select Campaign Category";
              
              if (!preg_match("#^http://www\..*#", $_POST["site_url"]) || !preg_match("#.(" . $setup->set["domains_allowed"] . ")#", $_POST["site_url"]))
                  $this->msgs['site_url'] = "Your domain name must start with &quot;http://www.&quot; and allowed extensions 
  are: " . str_replace("|", ", ", $setup->set["domains_allowed"]);
              
              if (empty($this->msgs)) {
                  $data = array(
				  'name' => sanitize($_POST['name']), 
				  'cat_id' => intval($_POST['cat_id']), 
				  'site_url' => sanitize($_POST['site_url']), 
				  'receive' => intval($_POST['receive'])
				  );
                  
                  $db->update("campaigns", $data, "id='" . $id . "'");
				  ($redirect) ? $redirect : $redirect = "campaigns.php?do=campaign&action=edit&id=" . $id;
                  
                  if ($db->affected())
                      redirect_to($redirect);
              } else {
                  $showMsg = '<div class="msgError"><span>Your campaign could not be updated due to the following error(s):</span><ul class="error">';
                  foreach ($this->msgs as $msg) {
                      $showMsg .= "<li>" . $msg . "</li>\n";
                  }
                  $showMsg .= '</ul></div>';
              }
          }
      }
      
      /**
       * Campaign::addCampaign()
       * 
       * @return
       */
      public function addCampaign($redirect = false)
      {
          global $db, $msgAlert, $setup, $showMsg;
          
          if (isset($_POST['add_campaign']) && $_POST['add_campaign'] == 1) {
              if ($_POST['name'] == "")
                  $this->msgs['name'] = "Please Enter Campaign Name";
              
              if ($_POST['cat_id'] == 0)
                  $this->msgs['cat_id'] = "Please Select Campaign Category";

              if(!preg_match("/(\.jpg|\.png|\.gif|\.bmp|\.jpeg|\.swf)$/i",$_FILES['banner']['name']))
                  $this->msgs['name'] = "Ilegal file type.Only jpg,png,gif and swf file types allowed.";
				  
              if ($_FILES['banner']['size'] > (600000))
                  $this->msgs['name'] = "Uploaded files must be less than 600k.";
				  
              if ($_FILES['banner']['name'] == "")
                  $this->msgs['name'] = "Please select Banner Image to upload";
              
              if (!preg_match("#^http://www\..*#", $_POST["site_url"]) || !preg_match("#.(" . $setup->set["domains_allowed"] . ")#", $_POST["site_url"]))
                  $this->msgs['site_url'] = "Your domain name must start with &quot;http://www.&quot; and allowed extensions 
  are: " . str_replace("|", ", ", $setup->set["domains_allowed"]);
              
              if (empty($this->msgs)) {
				  $status = ($setup->set['approval_type'] == 0) ? 0 : 1;
                  $data = array(
				  'name' => sanitize($_POST['name']), 
				  'cat_id' => intval($_POST['cat_id']), 
				  'site_url' => sanitize($_POST['site_url']), 
				  'receive' => intval($_POST['receive']), 
				  'user_id' => intval($_POST['user_id']), 
				  'active' => $status, 
				  'startedon' => "NOW()"
				  );
                  
                  $db->insert("campaigns", $data);
                  $lastId = $db->insertid();
                  
				  $status2 = ($setup->set['banner_approval_type'] == 0) ? 0 : 1;
				  
                  $data2 = array(
				  //'bannerurl' => $_FILES['banner']['name'], 
				  'weight' => intval($_POST['weight']), 
				  'type' => sanitize($_POST['type']), 
				  'size_id' => intval($_POST['size_id']), 
				  'campaign_id' => $lastId, 
				  'active' => $status2, 
				  'modified' => "NOW()", 
				  'submitted' => "NOW()"
				  );
                  
                  $bannerdir = BMPATH . "uploads/banners/";
				  $filename = stripslashes($_FILES['banner']['name']);
				  $extension = getExtension($filename);
				  $extension = strtolower($extension);
				  
				  $image_name = time().'.'.$extension;
				  $newname = $bannerdir . $image_name;
				  
				  $copied = copy($_FILES['banner']['tmp_name'], $newname);
				  $data['bannerurl'] = $image_name;

                  //$res = move_uploaded_file($_FILES['banner']['tmp_name'], $bannerdir . $_FILES['banner']['name']);
                  if ($copied)
                      $db->insert("ads", $data2);
					  
                  ($redirect) ? $redirect : $redirect = "campaigns.php?do=campaign&added=1";
                  if ($db->affected())
                      redirect_to($redirect);
              } else {
                  $showMsg = '<div class="msgError"><span>Your campaign could not be added due to the following error(s):</span><ul class="error">';
                  foreach ($this->msgs as $msg) {
                      $showMsg .= "<li>" . $msg . "</li>\n";
                  }
                  $showMsg .= '</ul></div>';
              }
          }
      }

      /**
       * Campaign::getCampaignByUserId()
       * 
       * @param mixed $user_id
       * @return
       */
      public function getCampaignByUserId($user_id)
      {
          global $db;
          
          $sql = "SELECT *,DATE_FORMAT(startedon,'%D %b,%Y') as date"
		  . "\n FROM campaigns WHERE user_id ='" . $db->escape((int)$user_id) . "'"
		  . "\n ORDER BY startedon DESC";
          $row = $db->fetch_all($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }

	  /**
	   * Campaign::updateImpressions()
	   * 
	   * @param mixed $user_id
	   * @return
	   */
	  public function updateImpressions($user_id, $redirect=false)
	  {
		  global $db, $msgAlert, $session, $setup, $showMsg;
		  
		  if (isset($_POST["type"]) && isset($_POST["credits"])) {
			  $user = $session->getUserById($user_id);
			  $camp = $this->getCampaignById($_POST["campaign_id"]);
			  
			  if (is_numeric($_POST["credits"]) && ($_POST["credits"] > 0)) {
				  if ($_POST["type"] == "1") {
					  if ($user["credits"] < $_POST["credits"])
						  $this->msgs['credits'] = "Not enough credits in account to transfer";
						  
					  if (empty($this->msgs)) {
						  $data['credits'] = $user["credits"] - $_POST["credits"];
						  $cdata['credits'] = $camp["credits"] + $_POST["credits"];
						  
						  $db->update("users", $data, "id='" . $user_id . "'");
						  $db->update("campaigns", $cdata, "id='" . (int)$_POST["campaign_id"] . "'");
						  
						  ($redirect) ? $redirect : $redirect = "campaigns.php?do=impressions&transfer=1&id=" . $user_id;
						  if ($db->affected())
							  redirect_to($redirect);
					  } else {
						  $showMsg = '<div class="msgError"><span>Your impressions could not be updated due to the following error(s):</span><ul class="error">';
						  foreach ($this->msgs as $msg) {
							  $showMsg .= "<li>" . $msg . "</li>\n";
						  }
						  $showMsg .= '</ul></div>';
					  }
				  } else {
					  $credits = round($camp["displays_gen"] / $setup->set["ratio1"] * $setup->set["ratio2"]) + $setup->set["click_reward"] * $camp["clicks_gen"] + $camp["credits"] - $camp["displays_rec"];
					  
					  if ($credits < $_POST["credits"])
						  $this->msgs['credits'] = "Not enough credits in account to transfer";
						  
					  if (empty($this->msgs)) {
						  $data['credits'] = $user["credits"] + $_POST["credits"];
						  $cdata['credits'] = $camp["credits"] - $_POST["credits"];
						  
						  $db->update("users", $data, "id='" . $user_id . "'");
						  $db->update("campaigns", $cdata, "id='" . (int)$_POST["campaign_id"] . "'");
						  
						  ($redirect) ? $redirect : $redirect = "campaigns.php?do=impressions&transfer=1&id=" . $user_id;
						  if ($db->affected())
							  redirect_to($redirect);
					  } else {
						  $showMsg = '<div class="msgError"><span>Your impressions could not be updated due to the following error(s):</span><ul class="error">';
						  foreach ($this->msgs as $msg) {
							  $showMsg .= "<li>" . $msg . "</li>\n";
						  }
						  $showMsg .= '</ul></div>';
					  }
				  }
			  }
		  }
	  }

      /**
       * Campaign::getCampaignSumById()
       * 
       * @param mixed $field
	   * @param mixed $user_id
       * @return
       */
      function getCampaignSumById($field, $user_id)
      {
          global $db;
          
          $sql = "SELECT sum($field) AS total FROM campaigns" 
		  . " \n WHERE user_id = '".(int)$user_id."' GROUP BY user_id";
          $row = $db->first($sql);
          
          if ($row) {
              return $row['total'];
          } else
              return $row['total'] = 0;
      }	
	  
      /**
       * Campaign::getInactiveCampaigns()
       * 
       * @return
       */
      public function getInactiveCampaigns()
      {
          global $db;
          
          $sql = "SELECT *,DATE_FORMAT(startedon,'%D %b,%Y') as date FROM campaigns"
		  . " \n WHERE active = '0'";
          $row = $db->fetch_all($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }

      /**
       * Campaign::getCampaignByLatest()
       * 
       * @param mixed $from
       * @param mixed $user_id
       * @return
       */
      public function getCampaignByLatest($table, $user_id)
      {
          global $db, $setup;
          
          $sql = "SELECT DATE_FORMAT(created,'%D %b,%Y at %r') as date FROM " . $table 
		  . " \n WHERE user_id = '" . $user_id . "'"
		  . " \n ORDER BY created DESC";
          $row = $db->first($sql);
		  
		  if ($row) {
              return $row['date'];
          } else
              return $setup->set["null_char"];
      }
	  
      /**
       * Campaign::getCampaignClicks()
       * 
       * @param mixed $from
       * @param mixed $campaign_id
       * @param mixed $date
       * @return
       */
      public function getCampaignClicks($from, $campaign_id, $date)
      {
          global $db;
          
          $sql = $db->query("SELECT * FROM " . $from 
		  . " \n WHERE campaign_id = '" . $campaign_id . "'  AND TO_DAYS(NOW())-TO_DAYS(created)" . $date . "");
          $clicks = $db->numrows($sql);
          
          if ($clicks)
              return $clicks;
      }
      
      /**
       * Campaign::getCampaignDisplays()
       * 
       * @param mixed $from
       * @param mixed $campaign_id
       * @param mixed $date
       * @return
       */
      public function getCampaignDisplays($from, $campaign_id, $date)
      {
          global $db;
          
          $sql = $db->query("SELECT * FROM " . $from 
		  . " \n WHERE campaign_id = '" . $campaign_id . "'  AND TO_DAYS(NOW())-TO_DAYS(created)" . $date . "");
          $displays = $db->numrows($sql);
          
          if ($displays)
              return $displays;
      }

      /**
       * Campaign::getBannerClicks()
       * 
       * @param mixed $from
       * @param mixed $campaign_id
       * @param mixed $date
       * @return
       */
      public function getBannerClicks($from, $user_id, $date)
      {
          global $db;
          
          $sql = $db->query("SELECT * FROM " . $from 
		  . " \n WHERE user_id = '" . $user_id . "'  AND TO_DAYS(NOW())-TO_DAYS(created)" . $date . "");
          $clicks = $db->numrows($sql);
          
          if ($clicks)
              return $clicks;
      }
      
      /**
       * Campaign::getBannerDisplays()
       * 
       * @param mixed $from
       * @param mixed $user_id
       * @param mixed $date
       * @return
       */
      public function getBannerDisplays($from, $user_id, $date)
      {
          global $db;
          
          $sql = $db->query("SELECT * FROM " . $from 
		  . " \n WHERE user_id = '" . $user_id . "'  AND TO_DAYS(NOW())-TO_DAYS(created)" . $date . "");
          $displays = $db->numrows($sql);
          
          if ($displays)
              return $displays;
      }

      /**
       * Campaign::getDisplays()
       * 
       * @param mixed $from
       * @param mixed $user_id
       * @param mixed $date
       * @return
       */
      public function getDisplays($from, $user_id, $date)
      {
          global $db;
          
          $sql = $db->query("SELECT * FROM " . $from 
		  . " \n WHERE user_id = '" . $user_id . "'  AND DATE_FORMAT(created,'%Y%m%e') = '" . $date ."'");
          $displays = $db->numrows($sql);
          
          if ($displays)
              return $displays;
      }
	  
      /**
       * Campaign::getAdsByCampaignId()
       * 
       * @param mixed $campaign_id
       * @return
       */
      public function getAdsByCampaignId($campaign_id)
      {
          global $db;
          
          $sql = "SELECT *, DATE_FORMAT(submitted,'%D %b,%Y') as created," 
		  . " \n DATE_FORMAT(modified,'%D %b,%Y') as updated" 
		  . " \n FROM ads WHERE campaign_id ='" . $db->escape((int)$campaign_id) . "'" 
		  . " \n ORDER BY weight DESC";
          $row = $db->fetch_all($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }
      
      /**
       * Campaign::getAdsById()
       * 
       * @param mixed $id
       * @return
       */
      public function getAdsById($id)
      {
          global $db;
          
          $sql = "SELECT * FROM ads WHERE id ='" . $db->escape((int)$id) . "'" 
		  . " \n ORDER BY weight DESC";
          $row = $db->first($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }

      /**
       * Campaign::addCampaignBanner()
       * 
       * @param mixed $campaign_id
       * @return
       */
      public function addCampaignBanner($campaign_id, $redirect=false)
      {
          global $db, $msgAlert, $setup, $showMsg;
          
          if (isset($_POST['add_banner']) && $_POST['add_banner'] == 1) {
              if ($_FILES['banner']['name'] == "")
                  $this->msgs['name'] = "Please select Banner Image to upload";

              if(!preg_match("/(\.jpg|\.png|\.gif|\.bmp|\.jpeg|\.swf)$/i",$_FILES['banner']['name']))
                  $this->msgs['name'] = "Ilegal file type.Only jpg,png,gif and swf file types allowed.";
				  
              if ($_FILES['banner']['size'] > (600000))
                  $this->msgs['name'] = "Uploaded files must be less than 600k.";
				  
              if (empty($this->msgs)) {
				  $status = ($setup->set['banner_approval_type'] == 0) ? 0 : 1;
                  $data = array(
				  //'bannerurl' => $_FILES['banner']['name'], 
				  'size_id' => intval($_POST['size_id']), 
				  'campaign_id' => intval($campaign_id), 
				  'type' => sanitize($_POST['type']), 
				  'weight' => intval($_POST['weight']), 
				  'submitted' => "NOW()", 
				  'modified' => "NOW()", 
				  'active' => $status
				  );
				  
                  $bannerdir = BMPATH . "uploads/banners/";
				  $filename = stripslashes($_FILES['banner']['name']);
				  $extension = getExtension($filename);
				  $extension = strtolower($extension);
				  
				  $image_name = time().'.'.$extension;
				  $newname = $bannerdir . $image_name;
				  
				  $copied = copy($_FILES['banner']['tmp_name'], $newname);
				  $data['bannerurl'] = $image_name;
				  
                  //$bannerdir = BMPATH . "uploads/banners/";
                  //$res = move_uploaded_file($_FILES['banner']['tmp_name'], $bannerdir . $_FILES['banner']['name']);
                  if ($copied)
                      $db->insert("ads", $data);
                  
				  ($redirect) ? $redirect : $redirect = "campaigns.php?do=ads&campaign_id=" . $campaign_id;
                  if ($db->affected() && $copied) {
                      redirect_to($redirect);
                  } else
                      $msgAlert = "Could not upload file";
              } else {
                  $showMsg = '<div class="msgError"><span>Your banner could not be uploaded due to the following error(s):</span><ul class="error">';
                  foreach ($this->msgs as $msg) {
                      $showMsg .= "<li>" . $msg . "</li>\n";
                  }
                  $showMsg .= '</ul></div>';
              }
          }
      }
      
      /**
       * Campaign::updateCampaignBanner()
       * 
       * @param mixed $id
       * @return
       */
      public function updateCampaignBanner($cid, $id, $redirect=false)
      {
          global $db, $msgAlert, $setup, $showMsg;
          
          $banner = $this->getAdsById($id);
          
          if (isset($_POST['update_banner']) && $_POST['update_banner'] == 1) {
              $data = array(
			  'size_id' => intval($_POST['size_id']), 
			  'weight' => intval($_POST['weight']), 
			  'type' => sanitize($_POST['type']), 
			  'modified' => "NOW()"
			  );
              
              $bannerdir = BMPATH . "uploads/banners/";
              
              if (!empty($_FILES['banner']['name'])) {
                  if ($banner['bannerurl']) //{
                      @unlink($bannerdir . $banner['bannerurl']);
					  
                  //$bannerdir = BMPATH . "uploads/banners/";
				  $filename = stripslashes($_FILES['banner']['name']);
				  $extension = getExtension($filename);
				  $extension = strtolower($extension);
				  
				  $image_name = time().'.'.$extension;
				  $newname = $bannerdir . $image_name;
				  
				  $copied = copy($_FILES['banner']['tmp_name'], $newname);
				  $data['bannerurl'] = $image_name;
                  //$res = move_uploaded_file($_FILES['banner']['tmp_name'], $bannerdir . $_FILES['banner']['name']);
                  //$data['bannerurl'] = $_FILES['banner']['name'];
				  //}
              } else {
                  $data['bannerurl'] = $banner['bannerurl'];
              }
              
              $db->update("ads", $data, "id='" . $id . "'");
			  ($redirect) ? $redirect : $redirect = "campaigns.php?do=ads&campaign_id=" . $cid;
              
              if ($db->affected()) {
                  redirect_to($redirect);
              } else
                  $msgAlert = "Could not upload file";
          }
      }

      /**
       * Campaign::getAdsById()
       * 
       * @param mixed $id
       * @return
       */
      public function getMostViewedAds($sort, $user_id)
      {
          global $db;
          
          $sql = "SELECT c.*, c.id AS id, a.id AS aid, a.size_id, a.bannerurl, a.weight, a.displays, a.type"
		  . " \n FROM campaigns AS c"
		  . " \n LEFT JOIN ads AS a ON a.campaign_id = c.id"
		  . " \n WHERE c.user_id ='" . $db->escape((int)$user_id) . "'" 
		  . " \n AND a.$sort <> 0"
		  . " \n ORDER BY a.$sort DESC";
          $row = $db->first($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }
	  
      /**
       * Campaign::getInactiveAds()
       * 
       * @return
       */
      public function getInactiveAds()
      {
          global $db;
          
          $sql = "SELECT *, DATE_FORMAT(submitted,'%D %b,%Y') as created" 
		  . " \n FROM ads WHERE active ='0'" 
		  . " \n ORDER BY submitted DESC";
          $row = $db->fetch_all($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }
	  
      /**
       * Campaign::getUserList()
       * 
       * @return
       */
      public function getUserList()
      {
          global $db;
          
          $sql = "SELECT id, username, email FROM users" 
		  . " \n ORDER BY username ASC";
          $row = $db->fetch_all($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }

      /**
       * Campaign::getUserListById()
       * 
       * @param mixed $id
       * @return
       */
      public function getUserListById($id)
      {
          global $db;
          
          $sql = "SELECT id, username, email, credits FROM users" 
		  . " \n WHERE id = '".$id."'";
          $row = $db->first($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }

      /**
       * Campaign::getCampaignPlanById()
       * 
	   * @param mixed $plan_id
       * @return
       */
      public function getCampaignPlanById($plan_id)
      {
          global $db;
          
          $sql = "SELECT * FROM plans WHERE id = '".$plan_id."'";
          $row = $db->first($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }
	  
      /**
       * Campaign::getCampaignPlans()
       * 
       * @return
       */
      public function getCampaignPlans()
      {
          global $db;
          
          $sql = "SELECT * FROM plans ORDER BY credits ASC";
          $row = $db->fetch_all($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }

      /**
       * Campaign::addPlan()
       * 
       * @return
       */
      public function addPlan()
      {
          global $db, $msgAlert, $showMsg;
          
          if (isset($_POST['add_plan']) && $_POST['add_plan'] == 1) {
              if ($_POST['credits'] == "")
                  $this->msgs['credits'] = "Please enter Plan Impressions";

              if ($_POST['price'] == "")
                  $this->msgs['price'] = "Please enter Plan Price";
				                
              if (empty($this->msgs)) {
                  $data = array(
				  'credits' => intval($_POST['credits']), 
				  'price' => intval($_POST['price']) 
				  );
				  
                   $db->insert("plans", $data);
                  
                  if ($db->affected())
                      redirect_to("campaigns.php?do=plan");
              } else {
                  $showMsg = '<div class="msgError"><span>Your plan could not be added due to the following error(s):</span><ul class="error">';
                  foreach ($this->msgs as $msg) {
                      $showMsg .= "<li>" . $msg . "</li>\n";
                  }
                  $showMsg .= '</ul></div>';
              }
          }
      }

      /**
       * Campaign::verifyTxnId()
       * 
       * @param mixed $txn_id
       * @return
       */
      function verifyTxnId($txn_id)
      {
          global $db;
          
          $sql = $db->query("SELECT id" 
				. "\n FROM transactions" 
				. "\n WHERE txn_id = '" . sanitize($txn_id) . "'" 
				. "\n LIMIT 1");
          if ($db->numrows($sql) > 0)
              return false;
          else
              return true;
      }
	  
      /**
       * Campaign::getTransactions()
       * 
       * @param bool $where
       * @param bool $user_id
       * @return
       */
      public function getTransactions($where = false, $user_id = false)
      {
          global $db, $setup, $pager;
          
          require_once(BMPATH . "lib/class_paginate.php");
          
          $pager = new Paginator();
          $counter = countEntries('transactions');
          $pager->items_total = $counter;
          $pager->default_ipp = $setup->set['perpage'];
          $pager->paginate();
          
          if ($counter == 0) {
              $pager->limit = "";
          }
          
		  ($where) ? $where = "WHERE u.username LIKE '%" . sanitize($where) . "%'" : "";
		  ($user_id) ? $where = "WHERE c.user_id = '".$user_id."'" : "";
		  
          $sql = "SELECT *,DATE_FORMAT(c.created,'%D %b,%Y') as date, c.id AS id, u.id AS uid, u.username, u.email"
		  ." \n FROM transactions AS c"
		  . "\n LEFT JOIN users AS u ON u.id = c.user_id" 
		  . "\n " . $where . "" 
		  . "\n ORDER BY c.created DESC " . $pager->limit;
          $row = $db->fetch_all($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }

      /**
       * Campaign::getUserTransactions()
       * 
       * @return
       */
      public function getUserTransactions()
      {
          global $db, $session;
          
          $sql = "SELECT *, DATE_FORMAT(created,'%D %b,%Y') as date" 
		  . " \n FROM transactions WHERE user_id ='".$session->userinfo['id']."'" 
		  . " \n ORDER BY created DESC";
          $row = $db->fetch_all($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }
	  
      /**
       * Campaign::addManualTransaction()
       * 
       * @param mixed $id
       * @return
       */
      public function addManualTransaction($id)
      {
          global $db, $msgAlert, $showMsg;
          
          if (isset($_POST['add_transaction']) && $_POST['add_transaction'] == 1) {
		  $user = $this->getUserListById($id);
              if ($_POST['amount'] == "")
                  $this->msgs['amount'] = "Please enter Transaction Credits";
				                
              if (empty($this->msgs)) {
                  $data = array(
				  'amount' => intval($_POST['amount']), 
				  'user_id' => intval($id),
				  'description' => sanitize($_POST['description']),
				  'created' => "NOW()",
				  'credit_type' => 0
				  
				  );
				  $udata['credits'] = $user['credits'] + $data['amount'];
				  
                   $db->insert("transactions", $data);
				   $db->update("users", $udata, "id='" . $id . "'");
                  
                  if ($db->affected())
                      redirect_to("campaigns.php?do=transactions&added=1");
              } else {
                  $showMsg = '<div class="msgError"><span>Your transaction could not be added due to the following error(s):</span><ul class="error">';
                  foreach ($this->msgs as $msg) {
                      $showMsg .= "<li>" . $msg . "</li>\n";
                  }
                  $showMsg .= '</ul></div>';
              }
          }
      }

      /**
       * Campaign::getTransactionSumById()
       * 
       * @param mixed $user_id
       * @return
       */
      function getTransactionSumById($user_id)
      {
          global $db;
          
          $sql = "SELECT sum(amount) AS total FROM transactions" 
		  . " \n WHERE user_id = '".(int)$user_id."' GROUP BY user_id";
          $row = $db->first($sql);
          
          if ($row) {
              $total =  $row['total'];
          } else
              $total = 0;
			  
		 return $total;	  
      }	  	  	        

      /**
       * Campaign::getCampaignFilter()
       * 
       * @return
       */
      public function getCampaignFilter()
      {
          $arr = array(
		  'name-ASC' => 'Campaign Name &uarr;', 
		  'name-DESC' => 'Campaign Name &darr;', 
		  'clicks_gen-ASC' => 'Clicks Generated &uarr;', 
		  'clicks_gen-DESC' => 'Clicks Generated &darr;', 
		  'displays_gen-ASC' => 'Displays Generated &uarr;', 
		  'displays_gen-DESC' => 'Displays Generated &darr;', 
		  'credits-ASC' => 'Availabl Credits &uarr;', 
		  'credits-DESC' => 'Availabl Credits &darr;', 
		  'user_id-ASC' => 'User Name &uarr;', 
		  'user_id-DESC' => 'User Name &darr;', 
		  'active-ASC' => 'Campaign Status &uarr;', 
		  'active-DESC' => 'Campaign Status &darr;'
		  );
          
          $filter = '';
          foreach ($arr as $key => $val) {
              if ($key == get('sort')) {
                  $filter .= "<option selected=\"selected\" value=\"$key\">$val</option>\n";
              } else
                  $filter .= "<option value=\"$key\">$val</option>\n";
          }
          unset($val);
          return $filter;
      }
      
      /**
       * Campaign::setActiveInactive()
       * 
       * @param mixed $table
       * @param mixed $redirect
       * @return
       */
      public function setActiveInactive($table, $redirect)
      {
          global $db, $msgError;
          
          if (isset($_GET['publish'])) {
              $id = intval($_GET['id']);
              
              $data['active'] = intval($_GET['publish']);
              
              $db->update($table, $data, "id='" . $id . "'");
              if ($db->affected() == 1)
                  redirect_to($redirect);
          }
      }
  }
?>