<?php
  /**
   * Categories
   *
   * @package Banner Exchange Manager
   * @author wojocms.com
   * @copyright 2010
   * @version $Id: class_categories.php,v 1.10 2010-04-30 14:20:26 gewa Exp $
   */
  if (!defined("_VALID_PHP"))
      die('Direct access to this location is not allowed.'); 
  
  class Category
  {
      public $msgs = array();
  
      function __construct()
      {
      }
      
      public function getCategoryById($id)
      {
          global $db;
          
          $sql = "SELECT * FROM categories WHERE id ='" . $db->escape((int)$id) . "'";
          $row = $db->first($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }
      
      public function getCategoryParent($parent_id)
      {
          global $db;
          
          $sql = "SELECT parent_id FROM categories WHERE id ='" . $db->escape((int)$parent_id) . "'";
          $row = $db->first($sql);
          
          if ($row) {
              return $row['parent_id'];
          } else
              return 0;
      }

      public function getAdminCatList($prefix, $parent_id)
      {
          global $db;
          
          $array = array();
          $sql = "SELECT id, name"
		  . "\n FROM categories"
		  . "\n WHERE parent_id='" . $db->escape((int)$parent_id) . "'"
		  . "\n ORDER BY position ASC, name ASC";
         
		 $result = $db->query($sql);
          
          while ($row = $db->fetch($result)) {
              $id = $row['id'];
              $row['name'] = $prefix . $db->escape(sanitize($row['name']));
			  
              $array[] = $row;
              $array = array_merge($array, $this->getAdminCatList($prefix . "&nbsp;&nbsp;&nbsp;&raquo;&nbsp;", $id));
          }
          return $array;
      }


      public function getCategoryTable($parent)
      {
          global $db;
          
          $sql = "SELECT id, name, parent_id, position"
		  . "\n FROM categories"
		  . "\n WHERE parent_id = '".$parent."'"
		  . "\n ORDER BY position ASC, name ASC";
         
		 $row = $db->fetch_all($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }

	  public function catNavigation($parent_id, $link, $msg = null)
	  {
		  global $db;
		  
		  $counter = 0;
		  
		  $msg = ($msg) ? $msg : "<strong>All Categories</strong>";
		  $display = '';
		  if ($parent_id > 0) {
			  $root_id = $parent_id;
			  while ($root_id > 0) {
				  $row = $db->first("SELECT id, name, parent_id FROM categories WHERE id=" . $root_id);
				  
				  if ($counter == 0) {
					  $display = (!empty($display)) ? $display : $row['name'];
				  } elseif ($parent_id != $root_id) {
					  $name = (!empty($name)) ? $name : $row['name'];
					  
					  $display = "<a href=\"" . $link . "&amp;parent_id=" . $row['id'] . "\">"
					  ."" . $name . "</a>&nbsp;&rsaquo;&nbsp;" . $display;
				  }
				  $counter++;
				  $root_id = $row['parent_id'];
			  }
			  $display = "<a href=\"" . $link . "\"><strong>Category:</strong></a>&nbsp;&rsaquo;&nbsp;" . $display;
		  }
		  
		  $display = (empty($display)) ? $msg : $display;
		  
		  return $display;
	  }
  
      public function updateCategory($id)
      {
          global $db, $setup, $msgError, $msgAlert, $msgOk, $showMsg;
          
          if (isset($_POST['update_cat'])) {
			
              if ($_POST['name'] == "")
                  $this->msgs['name'] = "Please Enter Category Name";
              
              if (empty($this->msgs)) {

				  $data = array(
						  'name' => sanitize($_POST['name']), 
						  'position' => intval($_POST['position'])
				  );

				  
                  $db->update("categories", $data, "id='" . $id . "'");
                  
                  if ($db->affected()) {
                      redirect_to("categories.php?do=category&action=edit&id=".$id."&parent_id=".$_POST['parent_id']);
                  } else 
                      $msgAlert = "<span>Alert!</span>Nothing to update";
              
			  } else {
                  $showMsg = "<div class=\"msgError\"><span>Your category could not be updated due to the following error(s):</span><ul class=\"error\">";
                  foreach ($this->msgs as $msg) {
                      $showMsg .= "<li>" . $msg . "</li>\n";
                  }
                  $showMsg .= '</ul></div>';
              }
          }
      }
      
      public function addCategory($parent_id)
      {
          global $db, $msgError, $showMsg;
          
          if (isset($_POST['add_cat'])) {
              if ($_POST['name'] == "")
                  $this->msgs['name'] = "Please Enter Category Name";
              
              if (empty($this->msgs)) {
				  
				  $data = array(
						  'name' => sanitize($_POST['name']), 
						  'parent_id' => intval($parent_id), 
						  'position' => intval($_POST['position'])
				  );

				  
                  $db->insert("categories", $data);
				  $lastid = $db->insertid();
                  
                  if ($db->affected())
                      redirect_to("categories.php?do=category&parent_id=".$parent_id."&id=".$lastid);
			  } else {
                  $showMsg = "<div class=\"msgError\"><span>Your category could not be added due to the following error(s):</span><ul class=\"error\">";
                  foreach ($this->msgs as $msg) {
                      $showMsg .= "<li>" . $msg . "</li>\n";
                  }
                  $showMsg .= '</ul></div>';
              }
          }
      }
          
      public function shiftCategories()
      {
          global $db, $msgError, $showMsg;
          
          if (isset($_POST['shift_order']) && $_POST['shift_order'] == 1) {
              if ($_POST['move_from'] == 0)
                  $this->msgs['move_from'] = "Please Select Move Listings From Category";

              if ($_POST['move_to'] == 0)
                  $this->msgs['move_to'] = "Please Select Move Listings To Category";
				                
              if (empty($this->msgs)) {
				  
				  $data['cat_id'] = intval($_POST['move_to']);

				  
                  $db->update("campaigns", $data, "cat_id='" . (int)$_POST['move_from'] . "'");
                  
                  if ($db->affected())
                      redirect_to("categories.php?do=category&shifted=1");
			  } else {
                  $showMsg = "<div class=\"msgError\"><span>Your category could not be added due to the following error(s):</span><ul class=\"error\">";
                  foreach ($this->msgs as $msg) {
                      $showMsg .= "<li>" . $msg . "</li>\n";
                  }
                  $showMsg .= '</ul></div>';
              }
          }
      }
 }
?>