<?php
  /**
   * Class Setup.php
   *
   * @package Banner Exchange Manager
   * @author wojocms.com
   * @copyright 2010
   * @version $Id: class_setup.php,v 1.10 2010-04-30 14:20:26 gewa Exp $
   */
  if (!defined("_VALID_PHP"))
      die('Direct access to this location is not allowed.');
  
  class Setup
  {
      public $set = array();
      public $msgs = array();
      
      /**
       * Setup::__construct()
       * 
       * @return
       */
      function __construct()
      {
          $this->set = $this->getSettings();
      }
      
      
      /**
       * Setup::getSettings()
       * 
       * @return
       */
      private function getSettings()
      {
          global $db;
          $sql = "SELECT * FROM setup";
          $row = $db->first($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }

      /**
       * Setup::updateSetup()
       * 
       * @return
       */
      public function updateSetup()
      {
          global $db, $msgAlert, $showMsg;
		  if (isset($_POST['update_settings']) && $_POST['update_settings'] == 1) {
              if (empty($_POST['site_name']))
                  $this->msgs['site_name'] = "Please enter valid Site Name!";

              if (empty($_POST['site_url']))
                  $this->msgs['site_url'] = "Please enter valid Site Url!";
				  
              if (empty($_POST['site_email']))
                  $this->msgs['site_email'] = "Please enter valid Site Email address!";

			  if (empty($_POST['paypal_id']))
                  $this->msgs['paypal_id'] = "Please enter valid PayPal Email Address!";

              if (empty($_POST['perpage']))
                  $this->msgs['perpage'] = "Please enter a numeric value(greater than 0) for Records Per Page!";
				  				  				                
			  if (empty($_POST['click_reward']))
                  $this->msgs['click_reward'] = "Please enter a numeric value for Click Rewards!";

			  if (empty($_POST['ratio1']))
                  $this->msgs['ratio1'] = "Please enter a numeric value for Exchange Ratio!";

			  if (empty($_POST['ratio2']))
                  $this->msgs['ratio2'] = "Please enter a numeric value for Exchange Ratio!";
				  
			  if (empty($_POST['bonus']))
                  $this->msgs['bonus'] = "Please enter a numeric value for Signup Bonus!";				  				  				

			  if (empty($_POST['null_char']))
                  $this->msgs['null_char'] = "Please enter a value for Null Character!";
				  
			  if (empty($_POST['currency']))
                  $this->msgs['currency'] = "Please enter a value for Currency";
				  
			  if (empty($_POST['cur_symbol']))
                  $this->msgs['cur_symbol'] = "Please enter a value for Currency Symbol";				  				  				    
              if (empty($this->msgs)) {
				  
                  $data = array(
						  'site_email' => sanitize($_POST['site_email']), 
						  'site_name' => sanitize($_POST['site_name']),
						  'site_url' => sanitize($_POST['site_url']),
						  'null_char' => sanitize($_POST['null_char']), 
						  'approval_type' => intval($_POST['approval_type']),
						  'banner_approval_type' => intval($_POST['banner_approval_type']),
						  'perpage' => intval($_POST['perpage']),
						  'paypal_id' => sanitize($_POST['paypal_id']),
						  'sandbox' => intval($_POST['sandbox']),
						  'click_reward' => sanitize($_POST['click_reward']),
						  'reg_verify' => intval($_POST['reg_verify']),
						  'currency' => sanitize($_POST['currency']),
						  'cur_symbol' => sanitize($_POST['cur_symbol']),
						  'ratio1' => intval($_POST['ratio1']),
						  'ratio2' => intval($_POST['ratio2']),
						  'domains_allowed' => sanitize($_POST['domains_allowed']),
						  'bonus' => intval($_POST['bonus']),
						  'captcha' => intval($_POST['captcha']),
						  'anticheat' => intval($_POST['anticheat']),
						  'metakeys' => sanitize($_POST['metakeys']),
						  'metadesc' => sanitize($_POST['metadesc'])
				  );
				  
				  $db->update("setup", $data);
				  if ($db->affected())
					  redirect_to("settings.php?do=settings&updated=1");

			  } else {
				  $showMsg = '<div class="msgError"><span>An error occurred while adding new transaction:</span><ul class="error">';
				  foreach ($this->msgs as $msg) {
					  $showMsg .= "<li>" . $msg . "</li>\n";
				  }
				  $showMsg .= '</ul></div>';
			  } 
		  }
	  }

      /**
       * Setup::getBannerSizeById()
       * 
       * @return
       */
      public function getBannerSizeById($id)
      {
          global $db;
          $sql = "SELECT * FROM banner_sizes WHERE id = '".$id."'";
          $row = $db->first($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }
	  
      /**
       * Setup::getIcons()
       * 
       * @return
       */
      public function getBannerSizes()
      {
          global $db;
          $sql = "SELECT * FROM banner_sizes ORDER BY width";
          $row = $db->fetch_all($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }

	  /**
	   * System::addBannerSize()
	   * 
	   * @return
	   */
	  public function addBannerSize()
	  {
		  global $db, $msgAlert, $setup, $showMsg;
		  
		  if (isset($_POST['add_bannersize']) && $_POST['add_bannersize'] == 1) {
				  if ($_FILES['default_banner']['name'] == "")
					  $this->msgs['name'] = "Please select File to upload";
				  
				  if ($_POST['width'] == "")
					  $this->msgs['width'] = "Please enter Banner Width";

				  if ($_POST['height'] == "")
					  $this->msgs['height'] = "Please enter Banner Height";
					  				  
				  if (empty($this->msgs)) {
					  $data = array(
							  'default_banner' => $_FILES['default_banner']['name'],
							  'width' => intval($_POST['width']), 
							  'height' => intval($_POST['height'])
					  );
					  $bannerdir = BMPATH . "uploads/bannersize/";
					  $res = move_uploaded_file($_FILES['default_banner']['tmp_name'], $bannerdir . $_FILES['default_banner']['name']);
					  if ($res)
						  $db->insert("banner_sizes", $data);
					  
					  if ($db->affected() && $res) {
						  redirect_to("settings.php?do=bannersize");
					  } else
						  $msgAlert = "Could not upload file";
				  } else {
					  $showMsg = '<div class="msgError"><span>Your file could not be uploaded due to the following error(s):</span><ul class="error">';
					  foreach ($this->msgs as $msg) {
						  $showMsg .= "<li>" . $msg . "</li>\n";
					  }
					  $showMsg .= '</ul></div>';
				  }
		  }
	  }

	  /**
	   * System::updateBannerSize()
	   * 
	   * @param mixed $id
	   * @return
	   */
	  public function updateBannerSize($id)
	  {
		  global $db, $msgAlert, $showMsg;
		  
		  $banner = $this->getBannerSizeById($id);
		  
		  if (isset($_POST['update_bannersize']) && $_POST['update_bannersize'] == 1) {
			  if ($_POST['width'] == "")
				  $this->msgs['width'] = "Please enter Banner Width";
			  
			  if ($_POST['height'] == "")
				  $this->msgs['height'] = "Please enter Banner Height";
			  
			  if (empty($this->msgs)) {
				  $data = array(
				  'width' => intval($_POST['width']),
				  'height' => intval($_POST['height'])
				  );
				  
				  $bannerdir = BMPATH . "uploads/bannersize/";
				  
				  if (!empty($_FILES['default_banner']['name'])) {
					  if ($banner['default_banner'])
						  @unlink($bannerdir . $banner['default_banner']);
					  $res = move_uploaded_file($_FILES['default_banner']['tmp_name'], $bannerdir . $_FILES['default_banner']['name']);
					  $data['default_banner'] = $_FILES['default_banner']['name'];
				  } else {
					  $data['default_banner'] = $banner['default_banner'];
				  }
				  
					  $db->update("banner_sizes", $data, "id='" . $id . "'");
				  
				  if ($db->affected()) {
					  redirect_to("settings.php?do=bannersize&action=edit&id=" . $id);
				  } else
					  $msgAlert = "Could not upload file";
			  } else {
				  $showMsg = '<div class="msgError"><span>Your file could not be uploaded due to the following error(s):</span><ul class="error">';
				  foreach ($this->msgs as $msg) {
					  $showMsg .= "<li>" . $msg . "</li>\n";
				  }
				  $showMsg .= '</ul></div>';
			  }
		  }
	  }

      /**
       * Setup::getBannedSiteById()
       * 
	   * @param mixed $id
       * @return
       */
      public function getBannedSiteById($id)
      {
          global $db;
          $sql = "SELECT * FROM banned_sites WHERE id = '".$id."'";
          $row = $db->first($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }
	  
      /**
       * Setup::getBannedSites()
       * 
       * @return
       */
      public function getBannedSites()
      {
          global $db;
          $sql = "SELECT * FROM banned_sites";
          $row = $db->fetch_all($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }

      /**
       * Setup::addBannedSite()
       * 
       * @return
       */
      public function addBannedSite()
      {
		  global $db, $msgAlert, $showMsg;
		  
		  if (isset($_POST['add_bannedsite']) && $_POST['add_bannedsite'] == 1) {
			  if ($_POST['name'] == "")
				  $this->msgs['name'] = "Please enter Banned Site Name";
				  
			  if (empty($this->msgs)) {
				  $data['name'] = sanitize($_POST['name']); 
					  $db->insert("banned_sites", $data);
					  $lastid = $db->insertid();
				  
				  if ($db->affected())
					  redirect_to("settings.php?do=bannedsite&id=".$lastid);

			  } else {
				  $showMsg = '<div class="msgError"><span>Your site could not be added due to the following error(s):</span><ul class="error">';
				  foreach ($this->msgs as $msg) {
					  $showMsg .= "<li>" . $msg . "</li>\n";
				  }
				  $showMsg .= '</ul></div>';
			  }
		  }
	  }
	  	  	  	  	  	  	  	  
      /**
       * Setup::getEmailTemplates()
       * 
       * @return
       */
      public function getEmailTemplates()
      {
          global $db;
          $sql = "SELECT * FROM email_templates";
          $row = $db->fetch_all($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }

      /**
       * Setup::getEmailTemplateById()
       * 
       * @param mixed $id
       * @return
       */
      public function getEmailTemplateById($id)
      {
          global $db;
          $sql = "SELECT * FROM email_templates WHERE id = '" . $id . "'";
          $row = $db->first($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }

      /**
       * Setup::updateEmailTemplate()
       * 
       * @param mixed $id
       * @return
       */
      public function updateEmailTemplate($id)
      {
          global $db, $msgAlert, $showMsg;
          
          if (isset($_POST['submit'])) {
              if ($_POST['name'] == "")
                  $this->msgs['name'] = "Template Title is required !";

              if ($_POST['subject'] == "")
                  $this->msgs['subject'] = "Template Subject is required !";

              if ($_POST['body'] == "")
                  $this->msgs['body'] = "Template Body is required !";
				  
              if (empty($this->msgs)) {
                  $data = array(
						  'name' => sanitize($_POST['name']), 
						  'subject' => sanitize($_POST['subject']),
						  'body' => $_POST['body']
				  );
                  
                  $db->update("email_templates", $data, "id='" . (int)$id . "'");
                  if ($db->affected()) {
                      redirect_to("settings.php?do=email&action=edit&id=".$id);
                  } else
                      $msgAlert = "<span>Alert!</span>Nothing to update.";
              } else {
                  $showMsg = '<div class="msgError"><span>An error occurred while updating template:</span><ul class="error">';
                  foreach ($this->msgs as $msg) {
                      $showMsg .= "<li>" . $msg . "</li>\n";
                  }
                  $showMsg .= '</ul></div>';
              }
          }
      }

	  /**
	   * Setup::sendMassMail()
	   * 
	   * @return
	   */
	  public function sendMassMail()
	  {
		  global $db, $msgOk, $mailer, $showMsg;
		  
		  if (isset($_POST['send_massmail']) && $_POST['send_massmail'] == 1) {
			  
			  if (empty($_POST['subject']))
				  $this->msgs['subject'] = "Email Subject is required !";
			  
			  if (empty($_POST['body']))
				  $this->msgs['body'] = "Email Body is required !";
			  
			  if (empty($this->msgs)) {
				  $sql = "SELECT email FROM users WHERE active = '1' AND userlevel = '1'";
				  $userrow = $db->fetch_all($sql);
				  
				  require_once(BMPATH . "lib/class_mailer.php");
				  
				  $subject = sanitize($_POST['subject']);
				  $body = $_POST['body'];
				  
				  foreach ($userrow as $row) {
					  $mail = $mailer->sendMail($row['email'], $subject, $body);
				  }
				  unset($row);
				  if ($mail) {
					  $msgOk = "<span>Succes!</span>Mass Mail sent successfuly!.";
				  } else {
					  $msgError = "<span>Error!</span>Mass Mail was not sent successfuly!.";
				  }
			  } else {
				  $showMsg = '<div class="msgError"><span>An error occurred while sending Mass Mail:</span><ul class="error">';
				  foreach ($this->msgs as $msg) {
					  $showMsg .= "<li>" . $msg . "</li>\n";
				  }
				  $showMsg .= '</ul></div>';
			  } 
		  }
	  }

	  /**
	   * Setup::sendSingleMail()
	   * 
	   * @return
	   */
	  public function sendSingleMail()
	  {
		  global $db, $msgOk, $mailer, $showMsg;
		  
		  if (isset($_POST['send_singlemail']) && $_POST['send_singlemail'] == 1) {
			  if (empty($_POST['to']))
				  $this->msgs['to'] = "Email Address To is required!";
				  			  
			  if (empty($_POST['subject']))
				  $this->msgs['subject'] = "Email Subject is required !";
			  
			  if (empty($_POST['body']))
				  $this->msgs['body'] = "Email Body is required !";
			  
			  if (empty($this->msgs)) {
				  
				  require_once(BMPATH . "lib/class_mailer.php");
				  
				  $to = sanitize($_POST['to']);
				  $subject = sanitize($_POST['subject']);
				  $body = $_POST['body'];
				  
				  $mail = $mailer->sendMail($to, $subject, $body);
				  
				  if ($mail) {
					  $msgOk = "<span>Succes!</span>Mail to " . $to . " sent successfuly!.";
				  } else {
					  $msgError = "<span>Error!</span>Mail to " . $to . " was not sent successfuly!.";
				  }
			  } else {
				  $showMsg = '<div class="msgError"><span>An error occurred while sending Mail:</span><ul class="error">';
				  foreach ($this->msgs as $msg) {
					  $showMsg .= "<li>" . $msg . "</li>\n";
				  }
				  $showMsg .= '</ul></div>';
			  } 
		  }
	  }

      /**
       * Setup::getUserIP()
       * 
	   * @param mixed $user_id
       * @return
       */
      public function getUserIP($user_id)
      {
          global $db;
          $sql = "SELECT * FROM ips WHERE user_id = '".$user_id."' AND ip = '".$_SERVER['REMOTE_ADDR']."'";
          $row = $db->first($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }
	  
      /**
       * Setup::totalIncome()
       * 
       * @return
       */
      public function totalIncome()
      {
          global $db;
          $sql = "SELECT (SELECT SUM(value) FROM transactions) AS total";
          $row = $db->first($sql);
          
          $total_income = number_format($row['total'], 2, '.', ',');
		  
		  return $total_income;
      }
	  
  }
?>