<?php
  /**
   * Class Users.php
   *
   * @package Banner Exchange Manager
   * @author wojocms.com
   * @copyright 2010
   * @version $Id: class_users.php,v 1.10 2010-04-30 14:20:26 gewa Exp $
   */
  if (!defined("_VALID_PHP"))
      die('Direct access to this location is not allowed.');
  
  class User
  {
      public $msgs = array();
      
      /**
       * User::__construct()
       * 
       * @return
       */
      function __construct()
      {
      }

      /**
       * User::confirmUserID()
       * 
       * @param mixed $username
       * @param mixed $cookie_id
       * @return
       */
      function confirmUserID($username, $cookie_id)
      {
          global $db;
          
          $sql = "SELECT cookie_id FROM users WHERE username = '" . $db->escape($username, true)."'";
          $result = $db->query($sql);
          if (!$result || (mysql_num_rows($result) < 1)) {
              return 1;
          }
          
          $row = $db->fetch($result);
          $row ['cookie_id'] = sanitize($row ['cookie_id']);
          $cookie_id = sanitize($cookie_id);
          
          if ($cookie_id == $row ['cookie_id']) {
              return 0;
          } else {
              return 2;
          }
      }

      /**
       * User::confirmUserPass()
       * 
       * @param mixed $username
       * @param mixed $password
       * @return
       */
      function confirmUserPass($username, $password)
      {
          global $db;

          $sql = "SELECT password,token, active FROM users WHERE username = '" . $db->escape($username, true)."'";
          $result = $db->query($sql);
          if (!$result) {
              return 0;
          }
          
          $row = $db->fetch($result);
          
          if ($row['token'] != 0)
              return 3;
			  
          if ($row['active'] != 1)
              return 4;          
          
          $row['password'] = sanitize($row['password']);
          $password = sanitize($password);
          
          $entered_pass = md5($password);
          
          if ($entered_pass == $row['password']) {
              return 1;
          } else {
              return 2;
          }
      }

      /**
       * User::setUserActive()
       * 
       * @param mixed $email
       * @param mixed $token
       * @return
       */
      function setUserActive($email, $token)
      {
          global $db;
          
		  $data['token'] = 0;
		  $data['active'] = 1;
		
		  $db->update("users", $data, "email = '" . $email . "' AND token = '" . $token . "' LIMIT 1");
          
          if ($db->affected() <= 0)
              return false;
          else
              return true;
      }

      /**
       * User::validateToken()
       * 
       * @param mixed $token
       * @return
       */
      function validateToken($token)
      {
          global $db;
          
          $sql = "SELECT token" 
		  . "\n FROM users" 
		  . "\n WHERE token ='" . $db->escape($token, true) . "'" 
		  . "\n LIMIT 1";
          $result = $db->query($sql);
          
          if (mysql_num_rows($result))
              return true;
      }

      /**
       * User::usernameExists()
       * 
       * @param mixed $username
       * @return
       */
      function usernameExists($username)
      {
          global $db;
          
          if (strlen($db->escape($username, true)) < 4)
              return 1;
          
          $alpha_num = str_replace(" ", "", $username);
          if (!ctype_alnum($alpha_num))
              return 2;
          
          $sql = $db->query("SELECT id" 
				. "\n FROM users" 
				. "\n WHERE username = '" . sanitize($username) . "'" 
				. "\n LIMIT 1");
          if ($db->numrows($sql) > 0)
              return 3;
          else
              return false;
      }

      /**
       * User::updateUserField()
       * 
       * @param mixed $username
       * @param mixed $field
       * @param mixed $value
       * @return
       */
      function updateUserField($username, $field, $value)
      {
          global $db;
		  
		  $username = sanitize($username);
		  $value = sanitize($value);
		  
		  $data[$field] = $value;
		  
		  $db->update("users", $data, "username='" . $db->escape($username, true) . "'");

      }

      /**
       * User::getUserInfo()
       * 
       * @param mixed $username
       * @return
       */
      function getUserInfo($username)
      {
          global $db;
          $sql = "SELECT * FROM users WHERE username = '" . $db->escape($username, true)."'";
          $result = $db->query($sql);
          if (!$username) {
              return false;
          }
          
          if (mysql_num_rows($result) > 0) {
              $row = $db->fetch($result);
              return $row;
          } else
              return null;
      }
	  
      /**
       * User::getUserById()
       * 
       * @param mixed $id
       * @return
       */
      public function getUserById($id)
      {
          global $db;
          $sql = "SELECT * FROM users WHERE id = '" . (int)$id . "'";
          $row = $db->first($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }

      /**
       * User::getUserList()
       * 
       * @return
       */
      public function getUserList()
      {
          global $db;
          $sql = "SELECT id, username,email FROM users ORDER BY username";
          $row = $db->fetch_all($sql);
          
          if ($row) {
              return $row;
          } else
              return 0;
      }
	  
      /**
       * User::getUsers()
       * 
       * @param bool $where
       * @param bool $letter
	   * @param bool $sort
       * @return
       */
	  public function getUsers($where = false, $letter = false, $sort = false)
      {
          global $db, $setup, $pager;
		  
		  require_once(BMPATH . "lib/class_paginate.php");

		  $pager = new Paginator();
		  $counter = countEntries('users');
		  $pager->items_total = $counter;
		  $pager->default_ipp = $setup->set['perpage'];
		  $pager->paginate();
		  
		  if ($counter == 0) {
			$pager->limit = "";
		  }
		  ($where) ? $where = "WHERE username LIKE '%".sanitize($where)."%'" : "";
		  ($letter) ? $where = "WHERE username REGEXP '^" . $db->escape(sanitize($letter)) . "'" : "";
		  ($sort) ? $order = sanitize($sort) : $order = "created DESC";
		  
          $sql = "SELECT *,"
		  ." \n DATE_FORMAT(created, '%d. %b. %Y.') as date,"
		  ." \n DATE_FORMAT(last_access, '%d. %b. %Y.') as access"
		  ." \n FROM users"
		  . "\n ".$where.""
		  ." \n ORDER BY " . $order.$pager->limit;
		  
          $row = $db->fetch_all($sql);
          
          return $row;

      }


      /**
       * User::addNewUser()
       * 
       * @param mixed $username
       * @param mixed $password
       * @param mixed $email
       * @param mixed $token
       * @return
       */
      function addNewUser($username, $password, $email, $token)
      {
          global $db, $setup;
		  
		  $status = ($setup->set['reg_verify'] == 1) ? 0 : 1;
		  $data = array(
				  'username' => $username, 
				  'password' => $password, 
				  'token' => $token, 
				  'cookie_id' => 0,
				  'userlevel' => 1,
				  'email' => $email,
				  'active' => $status,
				  'credits' => $setup->set['bonus'],
				  'last_ip' => $_SERVER['REMOTE_ADDR'],
				  'created' => "NOW()"
		  );
				  
		  $db->insert("users", $data);
		  $lastID = $db->insertid();
		  
		  if($setup->set['bonus'] > 0) {
		  $tdata = array(
				  'txn_id' => time(), 
				  'description' => "Signup Bonus", 
				  'amount' => $setup->set['bonus'], 
				  'value' => 0.00,
				  'user_id' => intval($lastID),
				  'created' => "NOW()",
				  'credit_type' => 0
		  );
		  
		  $db->insert("transactions", $tdata);
		  }

		  $idata = array(
				  'user_id' => $lastID, 
				  'ip' => $_SERVER['REMOTE_ADDR']
		  );
		  $db->insert("ips", $idata);
      }
	  
      /**
       * User::addUser()
       * 
       * @return
       */
      public function addUser()
      {
          global $db, $setup, $msgAlert, $showMsg, $mailer;
		  
          if (isset($_POST['add_user']) && $_POST['add_user'] == 1) {
              if (empty($_POST['username']))
                  $this->msgs['username'] = "Please enter Username";
              
              if (empty($_POST['password']))
                  $this->msgs['password'] = "Please enter User Password";
				  
              if (empty($_POST['email']))
                  $this->msgs['email'] = "Please enter User Email";

			  if ($this->emailExists($_POST['email']))
				  $this->msgs['email'] = "Entered Email Address is already in use.";
			  
			  if (!$this->isValidEmail($_POST['email']))
				  $this->msgs['email'] = "Entered Email Address is not valid.";
		  
              if (empty($_POST['name']))
                  $this->msgs['name'] = "Please enter User First and Lastname";

			  if ($value = $this->usernameExists($_POST['username'])) {
				  if ($value == 1)
					  $this->msgs['username'] = "Username is too short (less than 4 characters long)";
				  if ($value == 2)
					  $this->msgs['username'] = "Invalid characters found in Username";
				  if ($value == 3)
					  $this->msgs['username'] = "Sorry, this Username is already taken";
			  }
	  
              if (empty($this->msgs)) {
                  $data = array(
						  'username' => sanitize($_POST['username']), 
						  'password' => md5($_POST['password']), 
						  'email' => sanitize($_POST['email']), 
						  'name' => sanitize($_POST['name']),
						  'address' => sanitize($_POST['address']),
						  'city' => sanitize($_POST['city']),
						  'state' => sanitize($_POST['state']),
						  'url' => sanitize($_POST['url']),
						  'country' => sanitize($_POST['country']),
						  'userlevel' => intval($_POST['userlevel']),
						  'newsletter' => intval($_POST['newsletter']),
						  'active' => intval($_POST['active']),
						  'credits' => $setup->set['bonus'],
						  'created' => "NOW()"
				  );
                  
				  $db->insert("users", $data);
				  $lastID = $db->insertid();
				  
				  if($setup->set['bonus'] > 0) {
                  $tdata = array(
						  'txn_id' => time(), 
						  'description' => "Signup Bonus", 
						  'amount' => $setup->set['bonus'], 
						  'value' => 0.00,
						  'user_id' => intval($lastID),
						  'created' => "NOW()",
						  'credit_type' => 0
				  );
				  
				  $db->insert("transactions", $tdata);
				  }

                  $idata = array(
						  'user_id' => $lastID, 
						  'ip' => $_SERVER['REMOTE_ADDR']
				  );
				  $db->insert("ips", $idata);
				  
				  if ($db->affected())
					  if (intval($_POST['send_notify']) == 1) {
						  
						  require_once(BMPATH . "lib/class_mailer.php");
						  $mail_template = $setup->getEmailTemplateById(7);
				  
						  $body = str_replace(
							array('[USERNAME]', '[PASSWORD]', '[URL]', '[SITE_NAME]'), 
							array($data['username'], trim($_POST['password']), $setup->set['site_url'], $setup->set['site_name']), $mail_template['body']
							);
				  
							$mail = $mailer->sendMail($data['email'], $mail_template['subject'], $body);
						}
					
					redirect_to("users.php?do=users&added=1");
				} else {
					$showMsg = '<div class="msgError"><span>An error occurred while adding user:</span><ul class="error">';
					foreach ($this->msgs as $msg) {
						$showMsg .= "<li>" . $msg . "</li>\n";
					}
					$showMsg .= '</ul></div>';
				}
			}
		}

      /**
       * User::updateUser()
       * 
       * @param mixed $id
       * @return
       */
      public function updateUser($id)
      {
          global $db, $setup, $msgAlert, $showMsg;
		  
          if (isset($_POST['edit_user']) && $_POST['edit_user'] == 1) {
			  
			  $userrow = $this->getUserById($id);
				  
              if (empty($_POST['email']))
                  $this->msgs['email'] = "Please enter User Email";

			  if ($this->emailExists($_POST['email']) and $_POST['email'] != $userrow['email'])
				  $this->msgs['email'] = "Entered Email Address is already in use.";
			  
			  if (!$this->isValidEmail($_POST['email']))
				  $this->msgs['email'] = "Entered Email Address is not valid.";
		  
              if (empty($_POST['name']))
                  $this->msgs['name'] = "Please enter User First and Lastname";

	  
              if (empty($this->msgs)) {
                  $data = array(
						  'email' => sanitize($_POST['email']), 
						  'name' => sanitize($_POST['name']),
						  'address' => sanitize($_POST['address']),
						  'city' => sanitize($_POST['city']),
						  'state' => sanitize($_POST['state']),
						  'url' => sanitize($_POST['url']),
						  'country' => sanitize($_POST['country']),
						  'userlevel' => intval($_POST['userlevel']),
						  'newsletter' => intval($_POST['newsletter']),
						  'active' => intval($_POST['active'])
				  );
				  
				  if ($_POST['password'] != "") {
					  $data['password'] = md5($_POST['password']);
				  } else
					  $data['password'] = $userrow['password'];
					  
				  $db->update("users", $data, "id='" . $id . "'");
				  
				  if ($db->affected())
					redirect_to("users.php?do=users&action&action=edit&id=".$id);
				} else {
					$showMsg = '<div class="msgError"><span>An error occurred while updating user:</span><ul class="error">';
					foreach ($this->msgs as $msg) {
						$showMsg .= "<li>" . $msg . "</li>\n";
					}
					$showMsg .= '</ul></div>';
				}
			}
		}
		
      /**
       * User::emailExists()
       * 
       * @param mixed $email
       * @return
       */
      function emailExists($email)
      {
          global $db;
          
		  $email = sanitize($email);
          $sql = $db->query("SELECT id" 
				. "\n FROM users" 
				. "\n WHERE email = '" . $db->escape($email,true) . "'" 
				. "\n LIMIT 1");
          if (mysql_num_rows($sql) == 1)
              return true;
          else
              return false;
      }
	  
      /**
       * User::isValidEmail()
       * 
       * @param mixed $email
       * @return
       */
      function isValidEmail($email)
      {
          if (function_exists('filter_var')) {
              if (filter_var($email, FILTER_VALIDATE_EMAIL)) {
                  return true;
              } else {
                  return false;
              }
          } else {
              return preg_match('/^[a-zA-Z0-9._+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/', $email);
          }
      }
	  
      /**
       * User::getUserFilter()
       * 
       * @return
       */
      function getUserFilter()
      {

          $arr = array(
		  'id-ASC' => 'ID ASC &uarr;', 
		  'id-DESC' => 'ID DESC &darr;', 
		  'credits-ASC' => 'Credits ASC &uarr;', 
		  'credits-DESC' => 'Credits DESC &darr;', 
		  'email-ASC' => 'Email Address ASC &uarr;', 
		  'email-DESC' => 'Email Address DESC &darr;', 
		  'last_access-ASC' => 'Last Access ASC &uarr;', 
		  'last_access-DESC' => 'Last Access DESC &darr;', 
		  'active-ASC' => 'Status ASC &uarr;', 
		  'active-DESC' => 'Status DESC &darr;'
			);
          $filter = '';
          foreach ($arr as $key => $val) {
              if ($key == get('sort')) {
                  $filter .= "<option selected=\"selected\" value=\"$key\">$val</option>\n";
              } else
                  $filter .= "<option value=\"$key\">$val</option>\n";
          }
          unset($val);
          return $filter;
 
      }
	  
      /**
       * User::setActiveInactive()
       * 
       * @param mixed $table
       * @param mixed $redirect
       * @return
       */
      public function setActiveInactive($table, $redirect)
      {
          global $db, $msgError;
          
          if (isset($_GET['publish'])) {
              $id = intval($_GET['id']);
              
              $data['active'] = intval($_GET['publish']);
              
              $db->update($table, $data, "id='" . $id . "'");
              if ($db->affected() == 1)
                  redirect_to($redirect);
          }
      }
  }
?>