<?php
  /**
   * Functions.php
   *
   * @package Banner Exchange Manager
   * @author wojocms.com
   * @copyright 2010
   * @version $Id: functions.php,v 1.10 2010-04-30 14:20:26 gewa Exp $
   */
  if (!defined("_VALID_PHP"))
      die('Direct access to this location is not allowed.');
  
  /**
   * redirect_to()
   * 
   * @param mixed $location
   * @return
   */
  function redirect_to($location)
  {
      if (!headers_sent())
          header('Location: ' . $location);
      else {
          echo '<script type="text/javascript">';
          echo 'window.location.href="' . $location . '";';
          echo '</script>';
          echo '<noscript>';
          echo '<meta http-equiv="refresh" content="0;url=' . $location . '" />';
          echo '</noscript>';
      }
  }
  
  /**
   * countEntries()
   * 
   * @param mixed $table
   * @param string $where
   * @param string $what
   * @return
   */
  function countEntries($table, $where = '', $what = '')
  {
      global $db;
      if (!empty($where) && isset($what)) {
          $q = "SELECT COUNT(*) FROM " . $table . "  WHERE " . $where . " = '" . $what . "' LIMIT 1";
      } else
          $q = "SELECT COUNT(*) FROM " . $table . " LIMIT 1";
      
      $record = $db->query($q);
      $total = $db->fetchrow($record);
      return $total[0];
  }
  
  
  /**
   * display_msg()
   * 
   * @return
   */
  function display_msg()
  {
      global $msgOk, $msgError, $msgAlert, $msgInfo, $msgSys, $showMsg;
      
      if (!empty($msgOk)) {
          echo "<div id=\"fader\"><div class=\"msgOk\">" . $msgOk . "</div></div>
    <script type=\"text/javascript\"> 
    // <![CDATA[
    $(document).ready(function() {       
      setTimeout(function() {       
        $(\"#fader\").customFadeOut(\"slow\" ,    
        function() {       
          $(\"#fader\").remove();  
        });
      },
      4000);
    });
    // ]]>
    </script>";
      }
      if (!empty($msgError)) {
          echo "<div id=\"fader\"><div class=\"msgError\">" . $msgError . "</div></div>
    <script type=\"text/javascript\"> 
    // <![CDATA[
    $(document).ready(function() {       
      setTimeout(function() {       
        $(\"#fader\").customFadeOut(\"slow\",    
        function() {       
          $(\"#fader\").remove();  
        });
      },
      4000);
    });
    // ]]>
    </script>";
      }
      if (!empty($msgAlert)) {
          echo "<div id=\"fader\"><div class=\"msgAlert\">" . $msgAlert . "</div></div>
    <script type=\"text/javascript\"> 
    // <![CDATA[
    $(document).ready(function() {       
      setTimeout(function() {       
        $(\"#fader\").customFadeOut(\"slow\",    
        function() {       
          $(\"#fader\").remove();  
        });
      },
      4000);
    });
    // ]]>
    </script>";
      }
      if (!empty($msgInfo)) {
          echo "<div id=\"fader\"><div class=\"msgInfo\">" . $msgInfo . "</div></div>
    <script type=\"text/javascript\"> 
    // <![CDATA[
    $(document).ready(function() {       
      setTimeout(function() {       
        $(\"#fader\").customFadeOut(\"slow\",    
        function() {       
          $(\"#fader\").remove();  
        });
      },
      4000);
    });
    // ]]>
    </script>";
      }
      echo $showMsg;
  }
  
  /**
   * getChecked()
   * 
   * @param mixed $row
   * @param mixed $status
   * @return
   */
  function getChecked($row, $status)
  {
      if ($row == $status) {
          echo "checked=\"checked\"";
      }
  }
  
  /**
   * post()
   * 
   * @param mixed $var
   * @return
   */
  function post($var)
  {
      if (isset($_POST[$var]))
          return $_POST[$var];
  }
  
  /**
   * get()
   * 
   * @param mixed $var
   * @return
   */
  function get($var)
  {
      if (isset($_GET[$var]))
          return $_GET[$var];
  }
  
  /**
   * sanitize()
   * 
   * @param mixed $string
   * @param bool $trim
   * @return
   */
  function sanitize($string, $trim = false)
  {
      $string = filter_var($string, FILTER_SANITIZE_STRING);
      $string = trim($string);
      $string = stripslashes($string);
      $string = strip_tags($string);
      $string = str_replace(array('‘', '’', '“', '”'), array("'", "'", '"', '"'), $string);
      if ($trim)
          $string = substr($string, 0, $trim);
      
      return $string;
  }

  /**
   * abc()
   * 
   * @param mixed $all
   * @return
   */
  function abc($all = '')
  {
      $args = explode("&", $_SERVER['QUERY_STRING']);
      foreach ($args as $arg) {
          $keyval = explode("=", $arg);
          if ($keyval[0] != "letter")
              $string = "&amp;" . $arg;
      }
      $display = '';
      $display .= "<div id=\"abc\"><ul>\n";
      for ($i = 65; $i <= 90; $i++) {
          $key = chr($i);
          $display .= "<li><a href=\"" . htmlentities($_SERVER['PHP_SELF']) . "?letter=" . $key . $string . "\">" . $key . "</a></li>\n";
      }
      $viewAll = (!$all) ? htmlentities($_SERVER['PHP_SELF']) : $all;
      $display .= "<li><a href=\"" . $viewAll . "\">All</a></li>\n";
      $display .= "</ul></div><div class=\"clear\"></div>\n";
	  
	  return $display;
  }

  /**
   * getExtension()
   * 
   * @param mixed $str
   * @return
   */
  function getExtension($str)
  {
      $i = strrpos($str, ".");
      if (!$i) {
          return "";
      }
      $l = strlen($str) - $i;
      $ext = substr($str, $i + 1, $l);
      return $ext;
  }
      
  /**
   * getValue()
   * 
   * @param mixed $stwhatring
   * @param mixed $table
   * @param mixed $where
   * @return
   */
  function getValue($what, $table, $where)
  {
      global $db;
      $sql = "SELECT $what FROM $table WHERE $where";
      $row = $db->first($sql);
      return $row[$what];
  }  
  /**
   * self()
   * 
   * @return
   */
  function self()
  {
      return htmlspecialchars($_SERVER['PHP_SELF']);
  }
  
  /**
   * tooltip()
   * 
   * @param mixed $tip
   * @return
   */
  function tooltip($tip)
  {
      echo '<img src="' . ADMINURL . '/images/help2.png" alt="Tip" class="tooltip" title="' . $tip . '" />';
  }
  
  /**
   * required()
   * 
   * @return
   */
  function required()
  {
      echo '<img src="' . ADMINURL . '/images/required.png" alt="This is a required field." class="tooltip" title="This is a required field." />';
  }
?>